leetcode(top 100) 三数之和 相向双指针

题目:

给你一个整数数组 nums ,判断是否存在三元组 [nums[i], nums[j], nums[k]] 满足 i != j、i != k 且 j != k ,同时还满足 nums[i] + nums[j] + nums[k] == 0 。请

你返回所有和为 0 且不重复的三元组。

**注意:**答案中不可以包含重复的三元组。

题解:

第一步先对数组排序,然后依次枚举每一个数然后用查找两数之和的办法查找是否有两个数与当前枚举的数相加等于0。我认为本题的难点在于,在实现上述目标的基础上加上不可包含重复的三元组,这里相当于是一个小的数学知识,a,b,c三个数和是定值,如果这三个数中有两个数不变,那第三个值怎么变都是一样的,所以要想是非重复的三元组,在找到一组答案后再找下一组时至少要有两个数是与上次是不一样的。

cpp 复制代码
vector<vector<int>>ans;
    void f(int l,int r,vector<int>&arr,int k){ 
        while(l<r){
            if(arr[l]+arr[r]+arr[k]>0)r-=1;
            else if(arr[l]+arr[r]+arr[k]<0)l+=1;
            else {
                ans.push_back({arr[k],arr[l],arr[r]});
                //找下一组不重复的三元组
                l++;
                r--;
                while(l<r&&arr[l]==arr[l-1]){
                    l++;
                }
                while(l<r&&arr[r]==arr[r+1]){
                    r--;
                }
            }
        }

    }

    vector<vector<int>> threeSum(vector<int>& nums) {
        sort(nums.begin(),nums.end());
        for(int i=0;i<nums.size()-2;i++){
            //相同的数只用枚举查找一次即可
            if(i&&nums[i]==nums[i-1])continue;
            f(i+1,nums.size()-1,nums,i);
        }
        return ans;
    }

时间复杂度:O(n)

相关推荐
启观川12 小时前
数据结构与算法 -第 3 章 常用算法-动态规划
数据结构·笔记·python·算法
码爸12 小时前
排序算法介绍
python·算法·排序算法
Interview Aid11213 小时前
SoFi 面试流程全解析:技术面试、OA 与备考指南
面试·职场和发展
动词ing13 小时前
【题目练习】算法 组合总和||
算法
longlongzihan13 小时前
链表找环:Floyd 判圈算法(LeetCode 141 & 142 )
c++·算法·leetcode·链表
专业程序开发源13 小时前
flask家电故障预测系统92491-计算机课程设计/毕业设计
vscode·python·sql·算法·flask·课程设计
Logic10114 小时前
C语言/数据结构欧几里得算法题解:长方形切割最大正方形——贪心划分计数
c语言·数据结构·算法·贪心算法·时间复杂度·空间复杂度·欧几里得算法
yi01114 小时前
LeetCode 643. 子数组最大平均数 I|从暴力枚举到滑动窗口
人工智能·笔记·python·算法·leetcode·滑动窗口
YangYang9YangYan14 小时前
2027数学与应用数学转产品经理:面试解释与项目准备
面试·职场和发展·产品经理
极光通讯14 小时前
服务器内存来料检验(IQC)实操:批次追溯、外观判定与上机验证
java·服务器·算法